unit immunities;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type

TChecked = record
c1: BooLean;
c2: BooLean;
c3: BooLean;
c4: BooLean;
c5: BooLean;
c6: BooLean;
c7: BooLean;
c8: BooLean;
c9: BooLean;
c10: BooLean;
c11: BooLean;
c12: BooLean;
c13: BooLean;
end;

  TImmForm = class(TForm)
    Label1: TLabel;
    ch10: TCheckBox;
    ch11: TCheckBox;
    ch2: TCheckBox;
    ch12: TCheckBox;
    ch5: TCheckBox;
    ch3: TCheckBox;
    ch13: TCheckBox;
    ch8: TCheckBox;
    ch7: TCheckBox;
    ch6: TCheckBox;
    ch1: TCheckBox;
    ch9: TCheckBox;
    ch4: TCheckBox;
    t1: TComboBox;
    t2: TComboBox;
    t3: TComboBox;
    t4: TComboBox;
    procedure GameRead;
    procedure FlagSort(var check: Boolean; var flag: Longword; Position: Word);
    procedure ch1Click(Sender: TObject);
    procedure t1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ImmForm: TImmForm;
  Pointer: Integer;
  Checked: TChecked;
  FlagLock: Boolean;

implementation

uses main;

{$R *.dfm}

procedure TImmForm.FlagSort(var check: Boolean; var flag: Longword; Position: Word);
begin
if flag div Position = 1 then begin
 check:= True;
 flag:= flag - Position;
end
else begin
 check:= False;
end;
end;

procedure TImmForm.GameRead;
var
RByte: BYTE;
RLongWord: Longword;
begin
//Tires
MainForm.ReadMem(Pointer + 677,RByte,SizeOf(RByte));
if RByte = 0 then t1.Text:= 'Normal'
else if RByte = 1 then t1.Text:= 'Popped'
else if RByte = 2 then t1.Text:= 'No Tire';
MainForm.ReadMem(Pointer + 678,RByte,SizeOf(RByte));
if RByte = 0 then t2.Text:= 'Normal'
else if RByte = 1 then t2.Text:= 'Popped'
else if RByte = 2 then t2.Text:= 'No Tire';
MainForm.ReadMem(Pointer + 679,RByte,SizeOf(RByte));
if RByte = 0 then t3.Text:= 'Normal'
else if RByte = 1 then t3.Text:= 'Popped'
else if RByte = 2 then t3.Text:= 'No Tire';
MainForm.ReadMem(Pointer + 680,RByte,SizeOf(RByte));
if RByte = 0 then t4.Text:= 'Normal'
else if RByte = 1 then t4.Text:= 'Popped'
else if RByte = 2 then t4.Text:= 'No Tire';
//Immunities checkboxes
MainForm.ReadMem(Pointer + 82,RLongWord,SizeOf(RLongWord));
FlagSort(Checked.c13,RLongWord,4096);
FlagSort(Checked.c12,RLongWord,2048);
FlagSort(Checked.c11,RLongWord,1024);
FlagSort(Checked.c10,RLongWord,512);
FlagSort(Checked.c9,RLongWord,256);
FlagSort(Checked.c8,RLongWord,128);
FlagSort(Checked.c7,RLongWord,64);
FlagSort(Checked.c6,RLongWord,32);
FlagSort(Checked.c5,RLongWord,16);
FlagSort(Checked.c4,RLongWord,8);
FlagSort(Checked.c3,RLongWord,4);
FlagSort(Checked.c2,RLongWord,2);
FlagSort(Checked.c1,RLongWord,1);
FlagLock:= True;
ch1.Checked:= Checked.c1;
ch2.Checked:= Checked.c2;
ch3.Checked:= Checked.c3;
ch4.Checked:= Checked.c4;
ch5.Checked:= Checked.c5;
ch6.Checked:= Checked.c6;
ch7.Checked:= Checked.c7;
ch8.Checked:= Checked.c8;
ch9.Checked:= Checked.c9;
ch10.Checked:= Checked.c10;
ch11.Checked:= Checked.c11;
ch12.Checked:= Checked.c12;
ch13.Checked:= Checked.c13;
FlagLock:= False;
end;

procedure TImmForm.ch1Click(Sender: TObject);
var
flag: Longword;
begin
if FlagLock = False then begin
Checked.c1:= ch1.Checked;
Checked.c2:= ch2.Checked;
Checked.c3:= ch3.Checked;
Checked.c4:= ch4.Checked;
Checked.c5:= ch5.Checked;
Checked.c6:= ch6.Checked;
Checked.c7:= ch7.Checked;
Checked.c8:= ch8.Checked;
Checked.c9:= ch9.Checked;
Checked.c10:= ch10.Checked;
Checked.c11:= ch11.Checked;
Checked.c12:= ch12.Checked;
Checked.c13:= ch13.Checked;
flag:= 0;
if Checked.c1 = True then flag:= flag + 1;
if Checked.c2 = True then flag:= flag + 2;
if Checked.c3 = True then flag:= flag + 4;
if Checked.c4 = True then flag:= flag + 8;
if Checked.c5 = True then flag:= flag + 16;
if Checked.c6 = True then flag:= flag + 32;
if Checked.c7 = True then flag:= flag + 64;
if Checked.c8 = True then flag:= flag + 128;
if Checked.c9 = True then flag:= flag + 256;
if Checked.c10 = True then flag:= flag + 512;
if Checked.c11 = True then flag:= flag + 1024;
if Checked.c12 = True then flag:= flag + 2048;
if Checked.c13 = True then flag:= flag + 4096;
MainForm.WriteMem(Pointer + 82,flag,SizeOf(flag));
end;
end;

procedure TImmForm.t1Change(Sender: TObject);
var
RByte: BYTE;
begin
//Tires
if t1.Text = 'Normal' then RByte:= 0
else if t1.Text = 'Popped' then RByte:= 1
else if t1.Text = 'No Tire' then RByte:= 2;
MainForm.WriteMem(Pointer + 677,RByte,SizeOf(RByte));
if t2.Text = 'Normal' then RByte:= 0
else if t2.Text = 'Popped' then RByte:= 1
else if t2.Text = 'No Tire' then RByte:= 2;
MainForm.WriteMem(Pointer + 678,RByte,SizeOf(RByte));
if t3.Text = 'Normal' then RByte:= 0
else if t3.Text = 'Popped' then RByte:= 1
else if t3.Text = 'No Tire' then RByte:= 2;
MainForm.WriteMem(Pointer + 679,RByte,SizeOf(RByte));
if t4.Text = 'Normal' then RByte:= 0
else if t4.Text = 'Popped' then RByte:= 1
else if t4.Text = 'No Tire' then RByte:= 2;
MainForm.WriteMem(Pointer + 680,RByte,SizeOf(RByte));
end;

end.
