unit garageditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, StdCtrls, ExtCtrls;

type

TLocked = record
Sunshine1: Boolean;
Sunshine2: Boolean;
Sunshine3: Boolean;
Sunshine4: Boolean;
Sunshine5: Boolean;
Sunshine6: Boolean;
Sunshine7: Boolean;
Sunshine8: Boolean;
HymanCar1: Boolean;
HymanCar2: Boolean;
HymanCar3: Boolean;
HymanCar4: Boolean;
HymanCar5: Boolean;
HymanCar6: Boolean;
HymanCar7: Boolean;
HymanCar8: Boolean;
DiazCar1: Boolean;
DiazCar2: Boolean;
OceanCar: Boolean;
LinksCar: Boolean;
ElCar: Boolean;
end;

TColours = record
Sunshine1Maj: Integer;
Sunshine2Maj: Integer;
Sunshine3Maj: Integer;
Sunshine4Maj: Integer;
Sunshine5Maj: Integer;
Sunshine6Maj: Integer;
Sunshine7Maj: Integer;
Sunshine8Maj: Integer;
HymanCar1Maj: Integer;
HymanCar2Maj: Integer;
HymanCar3Maj: Integer;
HymanCar4Maj: Integer;
HymanCar5Maj: Integer;
HymanCar6Maj: Integer;
HymanCar7Maj: Integer;
HymanCar8Maj: Integer;
DiazCar1Maj: Integer;
DiazCar2Maj: Integer;
OceanCarMaj: Integer;
LinksCarMaj: Integer;
ElCarMaj: Integer;
Sunshine1Min: Integer;
Sunshine2Min: Integer;
Sunshine3Min: Integer;
Sunshine4Min: Integer;
Sunshine5Min: Integer;
Sunshine6Min: Integer;
Sunshine7Min: Integer;
Sunshine8Min: Integer;
HymanCar1Min: Integer;
HymanCar2Min: Integer;
HymanCar3Min: Integer;
HymanCar4Min: Integer;
HymanCar5Min: Integer;
HymanCar6Min: Integer;
HymanCar7Min: Integer;
HymanCar8Min: Integer;
DiazCar1Min: Integer;
DiazCar2Min: Integer;
OceanCarMin: Integer;
LinksCarMin: Integer;
ElCarMin: Integer;
end;

TCar = record
Sunshine1: Integer;
Sunshine2: Integer;
Sunshine3: Integer;
Sunshine4: Integer;
Sunshine5: Integer;
Sunshine6: Integer;
Sunshine7: Integer;
Sunshine8: Integer;
HymanCar1: Integer;
HymanCar2: Integer;
HymanCar3: Integer;
HymanCar4: Integer;
HymanCar5: Integer;
HymanCar6: Integer;
HymanCar7: Integer;
HymanCar8: Integer;
DiazCar1: Integer;
DiazCar2: Integer;
OceanCar: Integer;
LinksCar: Integer;
ElCar: Integer;
end;

TCarFlag = record
Bullet: Boolean;
Flame: Boolean;
Explosion: Boolean;
Damage: Boolean;
end;

TFlags = record
Sunshine1: TCarFlag;
Sunshine2: TCarFlag;
Sunshine3: TCarFlag;
Sunshine4: TCarFlag;
Sunshine5: TCarFlag;
Sunshine6: TCarFlag;
Sunshine7: TCarFlag;
Sunshine8: TCarFlag;
HymanCar1: TCarFlag;
HymanCar2: TCarFlag;
HymanCar3: TCarFlag;
HymanCar4: TCarFlag;
HymanCar5: TCarFlag;
HymanCar6: TCarFlag;
HymanCar7: TCarFlag;
HymanCar8: TCarFlag;
DiazCar1: TCarFlag;
DiazCar2: TCarFlag;
OceanCar: TCarFlag;
LinksCar: TCarFlag;
ElCar: TCarFlag;
end;

TGarage = record
Locked: TLocked;
Colours: TColours;
Car: TCar;
Flags: TFlags;
end;

  TGarageForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label11: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label14: TLabel;
    Label13: TLabel;
    Label12: TLabel;
    Label10: TLabel;
    Sun1Maj: TPaintBox;
    Sun1Min: TPaintBox;
    Sun2Maj: TPaintBox;
    Sun2Min: TPaintBox;
    Sun3Min: TPaintBox;
    Sun3Maj: TPaintBox;
    Sun4Min: TPaintBox;
    Sun4Maj: TPaintBox;
    Sun5Min: TPaintBox;
    Sun5Maj: TPaintBox;
    Sun6Min: TPaintBox;
    Sun6Maj: TPaintBox;
    Sun7Min: TPaintBox;
    Sun7Maj: TPaintBox;
    Sun8Min: TPaintBox;
    Sun8Maj: TPaintBox;
    hy1Maj: TPaintBox;
    hy1Min: TPaintBox;
    hy2Min: TPaintBox;
    hy2Maj: TPaintBox;
    hy3Min: TPaintBox;
    hy3Maj: TPaintBox;
    hy4Min: TPaintBox;
    hy4Maj: TPaintBox;
    hy5Min: TPaintBox;
    hy5Maj: TPaintBox;
    hy6Min: TPaintBox;
    hy6Maj: TPaintBox;
    hy7Min: TPaintBox;
    hy7Maj: TPaintBox;
    hy8Min: TPaintBox;
    hy8Maj: TPaintBox;
    di1Min: TPaintBox;
    di1Maj: TPaintBox;
    di2Min: TPaintBox;
    di2Maj: TPaintBox;
    oceMin: TPaintBox;
    oceMaj: TPaintBox;
    linksMin: TPaintBox;
    linksMaj: TPaintBox;
    elMin: TPaintBox;
    elMaj: TPaintBox;
    ElCar: TComboBox;
    LinksCar: TComboBox;
    OceanCar: TComboBox;
    DiazCar1: TComboBox;
    SunshineCar1: TComboBox;
    HymanCar1: TComboBox;
    SunshineGarage1: TCheckBox;
    HymanGarage1: TCheckBox;
    DiazGarage1: TCheckBox;
    OceanGarage: TCheckBox;
    LinksGarage: TCheckBox;
    ElGarage: TCheckBox;
    SunshineCar2: TComboBox;
    SunshineGarage2: TCheckBox;
    SunshineCar3: TComboBox;
    SunshineGarage3: TCheckBox;
    SunshineCar4: TComboBox;
    SunshineGarage4: TCheckBox;
    SunshineCar5: TComboBox;
    SunshineGarage5: TCheckBox;
    SunshineCar6: TComboBox;
    SunshineGarage6: TCheckBox;
    SunshineCar7: TComboBox;
    SunshineGarage7: TCheckBox;
    SunshineCar8: TComboBox;
    SunshineGarage8: TCheckBox;
    HymanCar2: TComboBox;
    HymanGarage2: TCheckBox;
    HymanCar3: TComboBox;
    HymanGarage3: TCheckBox;
    HymanCar4: TComboBox;
    HymanGarage4: TCheckBox;
    HymanCar5: TComboBox;
    HymanGarage5: TCheckBox;
    HymanCar6: TComboBox;
    HymanGarage6: TCheckBox;
    HymanCar7: TComboBox;
    HymanGarage7: TCheckBox;
    HymanCar8: TComboBox;
    HymanGarage8: TCheckBox;
    DiazCar2: TComboBox;
    DiazGarage2: TCheckBox;
    Sun1b: TCheckBox;
    Sun1f: TCheckBox;
    Sun2b: TCheckBox;
    Sun3b: TCheckBox;
    Sun4b: TCheckBox;
    Sun5b: TCheckBox;
    Sun6b: TCheckBox;
    Sun7b: TCheckBox;
    Sun8b: TCheckBox;
    hy1b: TCheckBox;
    hy2b: TCheckBox;
    hy3b: TCheckBox;
    hy4b: TCheckBox;
    hy5b: TCheckBox;
    hy6b: TCheckBox;
    hy7b: TCheckBox;
    hy8b: TCheckBox;
    di1b: TCheckBox;
    di2b: TCheckBox;
    oceb: TCheckBox;
    linkb: TCheckBox;
    elb: TCheckBox;
    Sun2f: TCheckBox;
    Sun3f: TCheckBox;
    Sun4f: TCheckBox;
    Sun5f: TCheckBox;
    Sun6f: TCheckBox;
    Sun7f: TCheckBox;
    Sun8f: TCheckBox;
    hy1f: TCheckBox;
    hy2f: TCheckBox;
    hy3f: TCheckBox;
    hy4f: TCheckBox;
    hy5f: TCheckBox;
    hy6f: TCheckBox;
    hy7f: TCheckBox;
    hy8f: TCheckBox;
    di1f: TCheckBox;
    di2f: TCheckBox;
    ocef: TCheckBox;
    linkf: TCheckBox;
    elf: TCheckBox;
    Sun1e: TCheckBox;
    Sun1d: TCheckBox;
    Sun2e: TCheckBox;
    Sun3e: TCheckBox;
    Sun4e: TCheckBox;
    Sun5e: TCheckBox;
    Sun6e: TCheckBox;
    Sun7e: TCheckBox;
    Sun8e: TCheckBox;
    hy1e: TCheckBox;
    hy2e: TCheckBox;
    hy3e: TCheckBox;
    hy4e: TCheckBox;
    hy5e: TCheckBox;
    hy6e: TCheckBox;
    hy7e: TCheckBox;
    hy8e: TCheckBox;
    di1e: TCheckBox;
    di2e: TCheckBox;
    ocee: TCheckBox;
    linke: TCheckBox;
    ele: TCheckBox;
    Sun2d: TCheckBox;
    Sun3d: TCheckBox;
    Sun4d: TCheckBox;
    Sun5d: TCheckBox;
    Sun6d: TCheckBox;
    Sun7d: TCheckBox;
    Sun8d: TCheckBox;
    hy1d: TCheckBox;
    hy2d: TCheckBox;
    hy3d: TCheckBox;
    hy4d: TCheckBox;
    hy5d: TCheckBox;
    hy6d: TCheckBox;
    hy7d: TCheckBox;
    hy8d: TCheckBox;
    di1d: TCheckBox;
    di2d: TCheckBox;
    oced: TCheckBox;
    linkd: TCheckBox;
    eld: TCheckBox;
    GarageAll: TCheckBox;
    ImmAll: TCheckBox;
    XPManifest1: TXPManifest;
    procedure PaintG(var box: TPaintBox; colour: BYTE);
    procedure FlagSort(var flags: TCarFlag; flag: Longword);
    procedure ReadGame;
    procedure SunshineCar1Change(Sender: TObject);
    procedure SunshineCar2Change(Sender: TObject);
    procedure SunshineCar3Change(Sender: TObject);
    procedure SunshineCar4Change(Sender: TObject);
    procedure SunshineCar5Change(Sender: TObject);
    procedure SunshineCar6Change(Sender: TObject);
    procedure SunshineCar7Change(Sender: TObject);
    procedure SunshineCar8Change(Sender: TObject);
    procedure HymanCar1Change(Sender: TObject);
    procedure HymanCar2Change(Sender: TObject);
    procedure HymanCar3Change(Sender: TObject);
    procedure HymanCar4Change(Sender: TObject);
    procedure HymanCar5Change(Sender: TObject);
    procedure HymanCar6Change(Sender: TObject);
    procedure HymanCar7Change(Sender: TObject);
    procedure HymanCar8Change(Sender: TObject);
    procedure DiazCar1Change(Sender: TObject);
    procedure DiazCar2Change(Sender: TObject);
    procedure OceanCarChange(Sender: TObject);
    procedure LinksCarChange(Sender: TObject);
    procedure ElCarChange(Sender: TObject);
    procedure SunshineGarage1Click(Sender: TObject);
    procedure SunshineGarage2Click(Sender: TObject);
    procedure SunshineGarage3Click(Sender: TObject);
    procedure SunshineGarage4Click(Sender: TObject);
    procedure SunshineGarage5Click(Sender: TObject);
    procedure SunshineGarage6Click(Sender: TObject);
    procedure SunshineGarage7Click(Sender: TObject);
    procedure SunshineGarage8Click(Sender: TObject);
    procedure HymanGarage1Click(Sender: TObject);
    procedure HymanGarage2Click(Sender: TObject);
    procedure HymanGarage3Click(Sender: TObject);
    procedure HymanGarage4Click(Sender: TObject);
    procedure HymanGarage5Click(Sender: TObject);
    procedure HymanGarage6Click(Sender: TObject);
    procedure HymanGarage7Click(Sender: TObject);
    procedure HymanGarage8Click(Sender: TObject);
    procedure DiazGarage1Click(Sender: TObject);
    procedure DiazGarage2Click(Sender: TObject);
    procedure OceanGarageClick(Sender: TObject);
    procedure LinksGarageClick(Sender: TObject);
    procedure ElGarageClick(Sender: TObject);
    procedure GarageAllClick(Sender: TObject);
    procedure ImmAllClick(Sender: TObject);
    procedure Sun1bClick(Sender: TObject);
    procedure Sun1MajDblClick(Sender: TObject);
    procedure Sun1MinDblClick(Sender: TObject);
    procedure Sun2MajDblClick(Sender: TObject);
    procedure Sun2MinDblClick(Sender: TObject);
    procedure Sun3MajDblClick(Sender: TObject);
    procedure Sun3MinDblClick(Sender: TObject);
    procedure Sun4MajDblClick(Sender: TObject);
    procedure Sun4MinDblClick(Sender: TObject);
    procedure Sun5MajDblClick(Sender: TObject);
    procedure Sun5MinDblClick(Sender: TObject);
    procedure Sun6MajDblClick(Sender: TObject);
    procedure Sun6MinDblClick(Sender: TObject);
    procedure Sun7MajDblClick(Sender: TObject);
    procedure Sun7MinDblClick(Sender: TObject);
    procedure Sun8MajDblClick(Sender: TObject);
    procedure Sun8MinDblClick(Sender: TObject);
    procedure hy1MajDblClick(Sender: TObject);
    procedure hy1MinDblClick(Sender: TObject);
    procedure hy2MajDblClick(Sender: TObject);
    procedure hy2MinDblClick(Sender: TObject);
    procedure hy3MajDblClick(Sender: TObject);
    procedure hy3MinDblClick(Sender: TObject);
    procedure hy4MajDblClick(Sender: TObject);
    procedure hy4MinDblClick(Sender: TObject);
    procedure hy5MajDblClick(Sender: TObject);
    procedure hy5MinDblClick(Sender: TObject);
    procedure hy6MajDblClick(Sender: TObject);
    procedure hy6MinDblClick(Sender: TObject);
    procedure hy7MajDblClick(Sender: TObject);
    procedure hy7MinDblClick(Sender: TObject);
    procedure hy8MajDblClick(Sender: TObject);
    procedure hy8MinDblClick(Sender: TObject);
    procedure di1MajDblClick(Sender: TObject);
    procedure di1MinDblClick(Sender: TObject);
    procedure di2MajDblClick(Sender: TObject);
    procedure di2MinDblClick(Sender: TObject);
    procedure oceMajDblClick(Sender: TObject);
    procedure oceMinDblClick(Sender: TObject);
    procedure linksMajDblClick(Sender: TObject);
    procedure linksMinDblClick(Sender: TObject);
    procedure elMajDblClick(Sender: TObject);
    procedure elMinDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GarageForm: TGarageForm;
  garage: TGarage;

implementation

uses main, coloureditor;

{$R *.dfm}

procedure TGarageForm.PaintG(var box: TPaintBox; colour: BYTE);
begin
box.Canvas.Brush.Color:= strtoint(main.INI.ReadString('colours',inttostr(colour), '$000000'));
box.Canvas.FillRect(box.Canvas.ClipRect);
end;

procedure TGarageForm.FlagSort(var flags: TCarFlag; flag: Longword);
var
Rdiv: Word;
Rmod: Word;
RWord: Word;
RFlag: Longword;
begin
//stuff for sorting out immunity flags
RFlag:= flag;
RWord:= 8;
Rdiv:= RFlag div RWord;
Rmod:= RFlag mod RWord;
if Rdiv = 1 then begin
 if Rmod = 0 then begin
  flags.Damage:= True;
  RFlag:= RFlag - RWord;
 end
 else begin
  flags.Damage:= True;
  RFlag:= RFlag - RWord;
 end
end
else begin
 flags.Damage:= False;
 RFlag:= RFlag;
end;

RWord:= 4;
Rdiv:= RFlag div RWord;
Rmod:= RFlag mod RWord;
if Rdiv = 1 then begin
 if Rmod = 0 then begin
  flags.Explosion:= True;
  RFlag:= RFlag - RWord;
 end
 else begin
  flags.Explosion:= True;
  RFlag:= RFlag - RWord;
 end
end
else begin
 flags.Explosion:= False;
 RFlag:= RFlag;
end;

RWord:= 2;
Rdiv:= RFlag div RWord;
Rmod:= RFlag mod RWord;
if Rdiv = 1 then begin
 if Rmod = 0 then begin
  flags.Flame:= True;
  RFlag:= RFlag - RWord;
 end
 else begin
  flags.Flame:= True;
  RFlag:= RFlag - RWord;
 end
end
else begin
 flags.Flame:= False;
 RFlag:= RFlag;
end;

RWord:= 1;
Rdiv:= RFlag div RWord;
Rmod:= RFlag mod RWord;
if Rdiv = 1 then begin
 if Rmod = 0 then begin
  flags.Bullet:= True;
  RFlag:= RFlag - RWord;
 end
 else begin
  flags.Bullet:= True;
  RFlag:= RFlag - RWord;
 end
end
else begin
 flags.Bullet:= False;
 RFlag:= RFlag;
end;
end;

procedure TGarageForm.ReadGame;
var
RInteger: Integer;
RLongword: Longword;
RByte: BYTE;
begin
//Get the car ID
//Sunshine Autos
MainForm.ReadMem($7D7878,RInteger,SizeOf(RInteger));
SunshineCar1.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine1:= RInteger;
MainForm.ReadMem($7D78A0,RInteger,SizeOf(RInteger));
SunshineCar2.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine2:= RInteger;
MainForm.ReadMem($7D7918,RInteger,SizeOf(RInteger));
SunshineCar3.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine3:= RInteger;
MainForm.ReadMem($7D7940,RInteger,SizeOf(RInteger));
SunshineCar4.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine4:= RInteger;
MainForm.ReadMem($7D79B8,RInteger,SizeOf(RInteger));
SunshineCar5.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine5:= RInteger;
MainForm.ReadMem($7D79E0,RInteger,SizeOf(RInteger));
SunshineCar6.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine6:= RInteger;
MainForm.ReadMem($7D7A58,RInteger,SizeOf(RInteger));
SunshineCar7.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine7:= RInteger;
MainForm.ReadMem($7D7A80,RInteger,SizeOf(RInteger));
SunshineCar8.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.Sunshine8:= RInteger;
//Hyman Stadium
MainForm.ReadMem($7D7558,RInteger,SizeOf(RInteger));
HymanCar1.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar1:= RInteger;
MainForm.ReadMem($7D7580,RInteger,SizeOf(RInteger));
HymanCar2.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar2:= RInteger;
MainForm.ReadMem($7D75A8,RInteger,SizeOf(RInteger));
HymanCar3.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar3:= RInteger;
MainForm.ReadMem($7D75D0,RInteger,SizeOf(RInteger));
HymanCar4.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar4:= RInteger;
MainForm.ReadMem($7D75F8,RInteger,SizeOf(RInteger));
HymanCar5.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar5:= RInteger;
MainForm.ReadMem($7D7620,RInteger,SizeOf(RInteger));
HymanCar6.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar6:= RInteger;
MainForm.ReadMem($7D7698,RInteger,SizeOf(RInteger));
HymanCar7.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar7:= RInteger;
MainForm.ReadMem($7D76C0,RInteger,SizeOf(RInteger));
HymanCar8.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.HymanCar8:= RInteger;
//Diaz Mansion
MainForm.ReadMem($7D7AF8,RInteger,SizeOf(RInteger));
DiazCar1.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.DiazCar1:= RInteger;
MainForm.ReadMem($7D7B20,RInteger,SizeOf(RInteger));
DiazCar2.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.DiazCar2:= RInteger;
//Others
MainForm.ReadMem($7D77D8,RInteger,SizeOf(RInteger));
OceanCar.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.OceanCar:= RInteger;
MainForm.ReadMem($7D7738,RInteger,SizeOf(RInteger));
LinksCar.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.LinksCar:= RInteger;
MainForm.ReadMem($7D74B8,RInteger,SizeOf(RInteger));
ElCar.Text:= main.INI.ReadString('carr', inttostr(RInteger), 'unknown');
Garage.Car.ElCar:= RInteger;
//
//sort out the flags
//
//SunShine Autos
MainForm.ReadMem($7D7894,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine1,RLongword);
MainForm.ReadMem($7D78BC,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine2,RLongword);
MainForm.ReadMem($7D7934,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine3,RLongword);
MainForm.ReadMem($7D795C,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine4,RLongword);
MainForm.ReadMem($7D79D4,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine5,RLongword);
MainForm.ReadMem($7D79FC,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine6,RLongword);
MainForm.ReadMem($7D7A74,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine7,RLongword);
MainForm.ReadMem($7D7A9C,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.Sunshine8,RLongword);
//Hyman Stadium
MainForm.ReadMem($7D7574,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar1,RLongword);
MainForm.ReadMem($7D759C,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar2,RLongword);
MainForm.ReadMem($7D75C4,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar3,RLongword);
MainForm.ReadMem($7D75EC,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar4,RLongword);
MainForm.ReadMem($7D7614,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar5,RLongword);
MainForm.ReadMem($7D763C,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar6,RLongword);
MainForm.ReadMem($7D76B4,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar7,RLongword);
MainForm.ReadMem($7D76DC,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.HymanCar8,RLongword);
//Others
MainForm.ReadMem($7D7B14,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.DiazCar1,RLongword);
MainForm.ReadMem($7D7B3C,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.DiazCar2,RLongword);
MainForm.ReadMem($7D7754,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.OceanCar,RLongword);
MainForm.ReadMem($7D77F4,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.LinksCar,RLongword);
MainForm.ReadMem($7D74D4,RLongword,SizeOf(RLongword));
FlagSort(garage.Flags.ElCar,RLongword);
//
//Colours
//
//SunShine Autos
MainForm.ReadMem($7D7898,RByte,SizeOf(RByte));
PaintG(Sun1Maj,RByte);
MainForm.ReadMem($7D789C,RByte,SizeOf(RByte));
PaintG(Sun1Min,RByte);
MainForm.ReadMem($7D78C0,RByte,SizeOf(RByte));
PaintG(Sun2Maj,RByte);
MainForm.ReadMem($7D78C4,RByte,SizeOf(RByte));
PaintG(Sun2Min,RByte);
MainForm.ReadMem($7D7938,RByte,SizeOf(RByte));
PaintG(Sun3Maj,RByte);
MainForm.ReadMem($7D793C,RByte,SizeOf(RByte));
PaintG(Sun3Min,RByte);
MainForm.ReadMem($7D7960,RByte,SizeOf(RByte));
PaintG(Sun4Maj,RByte);
MainForm.ReadMem($7D7964,RByte,SizeOf(RByte));
PaintG(Sun4Min,RByte);
MainForm.ReadMem($7D79D8,RByte,SizeOf(RByte));
PaintG(Sun5Maj,RByte);
MainForm.ReadMem($7D79DC,RByte,SizeOf(RByte));
PaintG(Sun5Min,RByte);
MainForm.ReadMem($7D7A00,RByte,SizeOf(RByte));
PaintG(Sun6Maj,RByte);
MainForm.ReadMem($7D7A04,RByte,SizeOf(RByte));
PaintG(Sun6Min,RByte);
MainForm.ReadMem($7D7A78,RByte,SizeOf(RByte));
PaintG(Sun7Maj,RByte);
MainForm.ReadMem($7D7A7C,RByte,SizeOf(RByte));
PaintG(Sun7Min,RByte);
MainForm.ReadMem($7D7AA0,RByte,SizeOf(RByte));
PaintG(Sun8Maj,RByte);
MainForm.ReadMem($7D7AA4,RByte,SizeOf(RByte));
PaintG(Sun8Min,RByte);
//Hyman Stadium
MainForm.ReadMem($7D7578,RByte,SizeOf(RByte));
PaintG(hy1Maj,RByte);
MainForm.ReadMem($7D757C,RByte,SizeOf(RByte));
PaintG(hy1Min,RByte);
MainForm.ReadMem($7D75A0,RByte,SizeOf(RByte));
PaintG(hy2Maj,RByte);
MainForm.ReadMem($7D75A4,RByte,SizeOf(RByte));
PaintG(hy2Min,RByte);
MainForm.ReadMem($7D75C8,RByte,SizeOf(RByte));
PaintG(hy3Maj,RByte);
MainForm.ReadMem($7D75CC,RByte,SizeOf(RByte));
PaintG(hy3Min,RByte);
MainForm.ReadMem($7D75F0,RByte,SizeOf(RByte));
PaintG(hy4Maj,RByte);
MainForm.ReadMem($7D75F4,RByte,SizeOf(RByte));
PaintG(hy4Min,RByte);
MainForm.ReadMem($7D7618,RByte,SizeOf(RByte));
PaintG(hy5Maj,RByte);
MainForm.ReadMem($7D761C,RByte,SizeOf(RByte));
PaintG(hy5Min,RByte);
MainForm.ReadMem($7D7640,RByte,SizeOf(RByte));
PaintG(hy6Maj,RByte);
MainForm.ReadMem($7D7644,RByte,SizeOf(RByte));
PaintG(hy6Min,RByte);
MainForm.ReadMem($7D76B8,RByte,SizeOf(RByte));
PaintG(hy7Maj,RByte);
MainForm.ReadMem($7D76BC,RByte,SizeOf(RByte));
PaintG(hy7Min,RByte);
MainForm.ReadMem($7D76E0,RByte,SizeOf(RByte));
PaintG(hy8Maj,RByte);
MainForm.ReadMem($7D76E4,RByte,SizeOf(RByte));
PaintG(hy8Min,RByte);
//Others
MainForm.ReadMem($7D7B18,RByte,SizeOf(RByte));
PaintG(di1Maj,RByte);
MainForm.ReadMem($7D7B1C,RByte,SizeOf(RByte));
PaintG(di1Min,RByte);
MainForm.ReadMem($7D7B40,RByte,SizeOf(RByte));
PaintG(di2Maj,RByte);
MainForm.ReadMem($7D7B44,RByte,SizeOf(RByte));
PaintG(di2Min,RByte);
MainForm.ReadMem($7D7758,RByte,SizeOf(RByte));
PaintG(oceMaj,RByte);
MainForm.ReadMem($7D775C,RByte,SizeOf(RByte));
PaintG(oceMin,RByte);
MainForm.ReadMem($7D77F8,RByte,SizeOf(RByte));
PaintG(LinksMaj,RByte);
MainForm.ReadMem($7D77FC,RByte,SizeOf(RByte));
PaintG(LinksMin,RByte);
MainForm.ReadMem($7D74D8,RByte,SizeOf(RByte));
PaintG(ElMaj,RByte);
MainForm.ReadMem($7D74DC,RByte,SizeOf(RByte));
PaintG(ElMin,RByte);
end;

procedure TGarageForm.SunshineCar1Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine1 = False then begin
if SunshineCar1.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar1.Items.Strings[SunshineCar1.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7878,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineCar2Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine2 = False then begin
if SunshineCar2.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar2.Items.Strings[SunshineCar2.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D78A0,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineCar3Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine3 = False then begin
if SunshineCar3.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar3.Items.Strings[SunshineCar3.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7918,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineCar4Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine4 = False then begin
if SunshineCar4.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar4.Items.Strings[SunshineCar4.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7940,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineCar5Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine5 = False then begin
if SunshineCar5.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar5.Items.Strings[SunshineCar5.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D79B8,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineCar6Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine6 = False then begin
if SunshineCar6.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar6.Items.Strings[SunshineCar6.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D79E0,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineCar7Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine7 = False then begin
if SunshineCar7.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar7.Items.Strings[SunshineCar7.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7A58,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineCar8Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.Sunshine8 = False then begin
if SunshineCar8.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', SunshineCar8.Items.Strings[SunshineCar8.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7A80,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar1Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar1 = False then begin
if HymanCar1.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar1.Items.Strings[HymanCar1.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7558,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar2Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar2 = False then begin
if HymanCar2.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar2.Items.Strings[HymanCar2.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7580,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar3Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar3 = False then begin
if HymanCar3.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar3.Items.Strings[HymanCar3.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D75A8,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar4Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar4 = False then begin
if HymanCar4.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar4.Items.Strings[HymanCar4.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D75D0,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar5Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar5 = False then begin
if HymanCar5.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar5.Items.Strings[HymanCar5.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D75F8,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar6Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar6 = False then begin
if HymanCar6.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar6.Items.Strings[HymanCar6.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7620,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar7Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar7 = False then begin
if HymanCar7.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar7.Items.Strings[HymanCar7.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7698,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.HymanCar8Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.HymanCar8 = False then begin
if HymanCar8.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', HymanCar8.Items.Strings[HymanCar8.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D76C0,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.DiazCar1Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.DiazCar1 = False then begin
if DiazCar1.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', DiazCar1.Items.Strings[DiazCar1.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7AF8,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.DiazCar2Change(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.DiazCar2 = False then begin
if DiazCar2.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', DiazCar2.Items.Strings[DiazCar2.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7B20,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.OceanCarChange(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.OceanCar = False then begin
if OceanCar.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', OceanCar.Items.Strings[OceanCar.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D7738,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.LinksCarChange(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.LinksCar = False then begin
if LinksCar.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', LinksCar.Items.Strings[LinksCar.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D77D8,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.ElCarChange(Sender: TObject);
var
Value: Integer;
begin
if Garage.Locked.ElCar = False then begin
if ElCar.ItemIndex >= 0 then begin
Value:= strtoint(main.INI.ReadString('car', ElCar.Items.Strings[ElCar.ItemIndex], 'error with settings.ini'));
MainForm.WriteMem($7D74B8,Value,SizeOf(Value));
end;
end;
end;

procedure TGarageForm.SunshineGarage1Click(Sender: TObject);
begin
Garage.Locked.Sunshine1:= SunshineGarage1.Checked;
end;

procedure TGarageForm.SunshineGarage2Click(Sender: TObject);
begin
Garage.Locked.Sunshine2:= SunshineGarage2.Checked;
end;

procedure TGarageForm.SunshineGarage3Click(Sender: TObject);
begin
Garage.Locked.Sunshine3:= SunshineGarage3.Checked;
end;

procedure TGarageForm.SunshineGarage4Click(Sender: TObject);
begin
Garage.Locked.Sunshine4:= SunshineGarage4.Checked;
end;

procedure TGarageForm.SunshineGarage5Click(Sender: TObject);
begin
Garage.Locked.Sunshine5:= SunshineGarage5.Checked;
end;

procedure TGarageForm.SunshineGarage6Click(Sender: TObject);
begin
Garage.Locked.Sunshine6:= SunshineGarage6.Checked;
end;

procedure TGarageForm.SunshineGarage7Click(Sender: TObject);
begin
Garage.Locked.Sunshine7:= SunshineGarage7.Checked;
end;

procedure TGarageForm.SunshineGarage8Click(Sender: TObject);
begin
Garage.Locked.Sunshine8:= SunshineGarage8.Checked;
end;

procedure TGarageForm.HymanGarage1Click(Sender: TObject);
begin
Garage.Locked.HymanCar1:= HymanGarage1.Checked;
end;

procedure TGarageForm.HymanGarage2Click(Sender: TObject);
begin
Garage.Locked.HymanCar2:= HymanGarage2.Checked;
end;

procedure TGarageForm.HymanGarage3Click(Sender: TObject);
begin
Garage.Locked.HymanCar3:= HymanGarage3.Checked;
end;

procedure TGarageForm.HymanGarage4Click(Sender: TObject);
begin
Garage.Locked.HymanCar4:= HymanGarage4.Checked;
end;

procedure TGarageForm.HymanGarage5Click(Sender: TObject);
begin
Garage.Locked.HymanCar5:= HymanGarage5.Checked;
end;

procedure TGarageForm.HymanGarage6Click(Sender: TObject);
begin
Garage.Locked.HymanCar6:= HymanGarage6.Checked;
end;

procedure TGarageForm.HymanGarage7Click(Sender: TObject);
begin
Garage.Locked.HymanCar7:= HymanGarage7.Checked;
end;

procedure TGarageForm.HymanGarage8Click(Sender: TObject);
begin
Garage.Locked.HymanCar8:= HymanGarage8.Checked;
end;

procedure TGarageForm.DiazGarage1Click(Sender: TObject);
begin
Garage.Locked.DiazCar1:= DiazGarage1.Checked;
end;

procedure TGarageForm.DiazGarage2Click(Sender: TObject);
begin
Garage.Locked.DiazCar2:= DiazGarage2.Checked;
end;

procedure TGarageForm.OceanGarageClick(Sender: TObject);
begin
Garage.Locked.OceanCar:= OceanGarage.Checked;
end;

procedure TGarageForm.LinksGarageClick(Sender: TObject);
begin
Garage.Locked.LinksCar:= LinksGarage.Checked;
end;

procedure TGarageForm.ElGarageClick(Sender: TObject);
begin
Garage.Locked.ElCar:= ElGarage.Checked;
end;

procedure TGarageForm.GarageAllClick(Sender: TObject);
begin
if GarageAll.Checked then begin
SunshineGarage1.Checked:= True;
SunshineGarage2.Checked:= True;
SunshineGarage3.Checked:= True;
SunshineGarage4.Checked:= True;
SunshineGarage5.Checked:= True;
SunshineGarage6.Checked:= True;
SunshineGarage7.Checked:= True;
SunshineGarage8.Checked:= True;
HymanGarage1.Checked:= True;
HymanGarage2.Checked:= True;
HymanGarage3.Checked:= True;
HymanGarage4.Checked:= True;
HymanGarage5.Checked:= True;
HymanGarage6.Checked:= True;
HymanGarage7.Checked:= True;
HymanGarage8.Checked:= True;
DiazGarage1.Checked:= True;
DiazGarage2.Checked:= True;
OceanGarage.Checked:= True;
LinksGarage.Checked:= True;
ElGarage.Checked:= True;
Garage.Locked.Sunshine1:= SunshineGarage1.Checked;
Garage.Locked.Sunshine2:= SunshineGarage2.Checked;
Garage.Locked.Sunshine3:= SunshineGarage3.Checked;
Garage.Locked.Sunshine4:= SunshineGarage4.Checked;
Garage.Locked.Sunshine5:= SunshineGarage5.Checked;
Garage.Locked.Sunshine6:= SunshineGarage6.Checked;
Garage.Locked.Sunshine7:= SunshineGarage7.Checked;
Garage.Locked.Sunshine8:= SunshineGarage8.Checked;
Garage.Locked.HymanCar1:= HymanGarage1.Checked;
Garage.Locked.HymanCar2:= HymanGarage2.Checked;
Garage.Locked.HymanCar3:= HymanGarage3.Checked;
Garage.Locked.HymanCar4:= HymanGarage4.Checked;
Garage.Locked.HymanCar5:= HymanGarage5.Checked;
Garage.Locked.HymanCar6:= HymanGarage6.Checked;
Garage.Locked.HymanCar7:= HymanGarage7.Checked;
Garage.Locked.HymanCar8:= HymanGarage8.Checked;
Garage.Locked.DiazCar1:= DiazGarage1.Checked;
Garage.Locked.DiazCar2:= DiazGarage2.Checked;
Garage.Locked.OceanCar:= OceanGarage.Checked;
Garage.Locked.LinksCar:= LinksGarage.Checked;
Garage.Locked.ElCar:= ElGarage.Checked;
end
else begin
SunshineGarage1.Checked:= False;
SunshineGarage2.Checked:= False;
SunshineGarage3.Checked:= False;
SunshineGarage4.Checked:= False;
SunshineGarage5.Checked:= False;
SunshineGarage6.Checked:= False;
SunshineGarage7.Checked:= False;
SunshineGarage8.Checked:= False;
HymanGarage1.Checked:= False;
HymanGarage2.Checked:= False;
HymanGarage3.Checked:= False;
HymanGarage4.Checked:= False;
HymanGarage5.Checked:= False;
HymanGarage6.Checked:= False;
HymanGarage7.Checked:= False;
HymanGarage8.Checked:= False;
DiazGarage1.Checked:= False;
DiazGarage2.Checked:= False;
OceanGarage.Checked:= False;
LinksGarage.Checked:= False;
ElGarage.Checked:= False;
Garage.Locked.Sunshine1:= SunshineGarage1.Checked;
Garage.Locked.Sunshine2:= SunshineGarage2.Checked;
Garage.Locked.Sunshine3:= SunshineGarage3.Checked;
Garage.Locked.Sunshine4:= SunshineGarage4.Checked;
Garage.Locked.Sunshine5:= SunshineGarage5.Checked;
Garage.Locked.Sunshine6:= SunshineGarage6.Checked;
Garage.Locked.Sunshine7:= SunshineGarage7.Checked;
Garage.Locked.Sunshine8:= SunshineGarage8.Checked;
Garage.Locked.HymanCar1:= HymanGarage1.Checked;
Garage.Locked.HymanCar2:= HymanGarage2.Checked;
Garage.Locked.HymanCar3:= HymanGarage3.Checked;
Garage.Locked.HymanCar4:= HymanGarage4.Checked;
Garage.Locked.HymanCar5:= HymanGarage5.Checked;
Garage.Locked.HymanCar6:= HymanGarage6.Checked;
Garage.Locked.HymanCar7:= HymanGarage7.Checked;
Garage.Locked.HymanCar8:= HymanGarage8.Checked;
Garage.Locked.DiazCar1:= DiazGarage1.Checked;
Garage.Locked.DiazCar2:= DiazGarage2.Checked;
Garage.Locked.OceanCar:= OceanGarage.Checked;
Garage.Locked.LinksCar:= LinksGarage.Checked;
Garage.Locked.ElCar:= ElGarage.Checked;
end;
end;

procedure TGarageForm.ImmAllClick(Sender: TObject);
begin
Sun1b.Checked:= ImmAll.Checked;
Sun1f.Checked:= ImmAll.Checked;
Sun1e.Checked:= ImmAll.Checked;
Sun1d.Checked:= ImmAll.Checked;
Sun2b.Checked:= ImmAll.Checked;
Sun2f.Checked:= ImmAll.Checked;
Sun2e.Checked:= ImmAll.Checked;
Sun2d.Checked:= ImmAll.Checked;
Sun3b.Checked:= ImmAll.Checked;
Sun3f.Checked:= ImmAll.Checked;
Sun3e.Checked:= ImmAll.Checked;
Sun3d.Checked:= ImmAll.Checked;
Sun4b.Checked:= ImmAll.Checked;
Sun4f.Checked:= ImmAll.Checked;
Sun4e.Checked:= ImmAll.Checked;
Sun4d.Checked:= ImmAll.Checked;
Sun5b.Checked:= ImmAll.Checked;
Sun5f.Checked:= ImmAll.Checked;
Sun5e.Checked:= ImmAll.Checked;
Sun5d.Checked:= ImmAll.Checked;
Sun6b.Checked:= ImmAll.Checked;
Sun6f.Checked:= ImmAll.Checked;
Sun6e.Checked:= ImmAll.Checked;
Sun6d.Checked:= ImmAll.Checked;
Sun7b.Checked:= ImmAll.Checked;
Sun7f.Checked:= ImmAll.Checked;
Sun7e.Checked:= ImmAll.Checked;
Sun7d.Checked:= ImmAll.Checked;
Sun8b.Checked:= ImmAll.Checked;
Sun8f.Checked:= ImmAll.Checked;
Sun8e.Checked:= ImmAll.Checked;
Sun8d.Checked:= ImmAll.Checked;
hy1b.Checked:= ImmAll.Checked;
hy1f.Checked:= ImmAll.Checked;
hy1e.Checked:= ImmAll.Checked;
hy1d.Checked:= ImmAll.Checked;
hy2b.Checked:= ImmAll.Checked;
hy2f.Checked:= ImmAll.Checked;
hy2e.Checked:= ImmAll.Checked;
hy2d.Checked:= ImmAll.Checked;
hy3b.Checked:= ImmAll.Checked;
hy3f.Checked:= ImmAll.Checked;
hy3e.Checked:= ImmAll.Checked;
hy3d.Checked:= ImmAll.Checked;
hy4b.Checked:= ImmAll.Checked;
hy4f.Checked:= ImmAll.Checked;
hy4e.Checked:= ImmAll.Checked;
hy4d.Checked:= ImmAll.Checked;
hy5b.Checked:= ImmAll.Checked;
hy5f.Checked:= ImmAll.Checked;
hy5e.Checked:= ImmAll.Checked;
hy5d.Checked:= ImmAll.Checked;
hy6b.Checked:= ImmAll.Checked;
hy6f.Checked:= ImmAll.Checked;
hy6e.Checked:= ImmAll.Checked;
hy6d.Checked:= ImmAll.Checked;
hy7b.Checked:= ImmAll.Checked;
hy7f.Checked:= ImmAll.Checked;
hy7e.Checked:= ImmAll.Checked;
hy7d.Checked:= ImmAll.Checked;
hy8b.Checked:= ImmAll.Checked;
hy8f.Checked:= ImmAll.Checked;
hy8e.Checked:= ImmAll.Checked;
hy8d.Checked:= ImmAll.Checked;
di1b.Checked:= ImmAll.Checked;
di1f.Checked:= ImmAll.Checked;
di1e.Checked:= ImmAll.Checked;
di1d.Checked:= ImmAll.Checked;
di2b.Checked:= ImmAll.Checked;
di2f.Checked:= ImmAll.Checked;
di2e.Checked:= ImmAll.Checked;
di2d.Checked:= ImmAll.Checked;
oceb.Checked:= ImmAll.Checked;
ocef.Checked:= ImmAll.Checked;
ocee.Checked:= ImmAll.Checked;
oced.Checked:= ImmAll.Checked;
linkb.Checked:= ImmAll.Checked;
linkf.Checked:= ImmAll.Checked;
linke.Checked:= ImmAll.Checked;
linkd.Checked:= ImmAll.Checked;
elb.Checked:= ImmAll.Checked;
elf.Checked:= ImmAll.Checked;
ele.Checked:= ImmAll.Checked;
eld.Checked:= ImmAll.Checked;
Garage.Flags.Sunshine1.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine1.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine1.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine1.Damage:= ImmAll.Checked;
Garage.Flags.Sunshine2.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine2.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine2.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine2.Damage:= ImmAll.Checked;
Garage.Flags.Sunshine3.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine3.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine3.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine3.Damage:= ImmAll.Checked;
Garage.Flags.Sunshine4.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine4.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine4.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine4.Damage:= ImmAll.Checked;
Garage.Flags.Sunshine5.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine5.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine5.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine5.Damage:= ImmAll.Checked;
Garage.Flags.Sunshine6.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine6.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine6.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine6.Damage:= ImmAll.Checked;
Garage.Flags.Sunshine7.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine7.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine7.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine7.Damage:= ImmAll.Checked;
Garage.Flags.Sunshine8.Bullet:= ImmAll.Checked;
Garage.Flags.Sunshine8.Flame:= ImmAll.Checked;
Garage.Flags.Sunshine8.Explosion:= ImmAll.Checked;
Garage.Flags.Sunshine8.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar1.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar1.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar1.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar1.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar2.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar2.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar2.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar2.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar3.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar3.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar3.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar3.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar4.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar4.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar4.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar4.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar5.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar5.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar5.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar5.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar6.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar6.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar6.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar6.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar7.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar7.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar7.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar7.Damage:= ImmAll.Checked;
Garage.Flags.HymanCar8.Bullet:= ImmAll.Checked;
Garage.Flags.HymanCar8.Flame:= ImmAll.Checked;
Garage.Flags.HymanCar8.Explosion:= ImmAll.Checked;
Garage.Flags.HymanCar8.Damage:= ImmAll.Checked;
Garage.Flags.DiazCar1.Bullet:= ImmAll.Checked;
Garage.Flags.DiazCar1.Flame:= ImmAll.Checked;
Garage.Flags.DiazCar1.Explosion:= ImmAll.Checked;
Garage.Flags.DiazCar1.Damage:= ImmAll.Checked;
Garage.Flags.DiazCar2.Bullet:= ImmAll.Checked;
Garage.Flags.DiazCar2.Flame:= ImmAll.Checked;
Garage.Flags.DiazCar2.Explosion:= ImmAll.Checked;
Garage.Flags.DiazCar2.Damage:= ImmAll.Checked;
Garage.Flags.OceanCar.Bullet:= ImmAll.Checked;
Garage.Flags.OceanCar.Flame:= ImmAll.Checked;
Garage.Flags.OceanCar.Explosion:= ImmAll.Checked;
Garage.Flags.OceanCar.Damage:= ImmAll.Checked;
Garage.Flags.LinksCar.Bullet:= ImmAll.Checked;
Garage.Flags.LinksCar.Flame:= ImmAll.Checked;
Garage.Flags.LinksCar.Explosion:= ImmAll.Checked;
Garage.Flags.LinksCar.Damage:= ImmAll.Checked;
Garage.Flags.ElCar.Bullet:= ImmAll.Checked;
Garage.Flags.ElCar.Flame:= ImmAll.Checked;
Garage.Flags.ElCar.Explosion:= ImmAll.Checked;
Garage.Flags.ElCar.Damage:= ImmAll.Checked;
end;

procedure TGarageForm.Sun1bClick(Sender: TObject);
begin
Garage.Flags.Sunshine1.Bullet:= Sun1b.Checked;
Garage.Flags.Sunshine1.Flame:= Sun1f.Checked;
Garage.Flags.Sunshine1.Explosion:= Sun1e.Checked;
Garage.Flags.Sunshine1.Damage:= Sun1d.Checked;
Garage.Flags.Sunshine2.Bullet:= Sun2b.Checked;
Garage.Flags.Sunshine2.Flame:= Sun2f.Checked;
Garage.Flags.Sunshine2.Explosion:= Sun2e.Checked;
Garage.Flags.Sunshine2.Damage:= Sun2d.Checked;
Garage.Flags.Sunshine3.Bullet:= Sun3b.Checked;
Garage.Flags.Sunshine3.Flame:= Sun3f.Checked;
Garage.Flags.Sunshine3.Explosion:= Sun3e.Checked;
Garage.Flags.Sunshine3.Damage:= Sun3d.Checked;
Garage.Flags.Sunshine4.Bullet:= Sun4b.Checked;
Garage.Flags.Sunshine4.Flame:= Sun4f.Checked;
Garage.Flags.Sunshine4.Explosion:= Sun4e.Checked;
Garage.Flags.Sunshine4.Damage:= Sun4d.Checked;
Garage.Flags.Sunshine5.Bullet:= Sun5b.Checked;
Garage.Flags.Sunshine5.Flame:= Sun5f.Checked;
Garage.Flags.Sunshine5.Explosion:= Sun5e.Checked;
Garage.Flags.Sunshine5.Damage:= Sun5d.Checked;
Garage.Flags.Sunshine6.Bullet:= Sun6b.Checked;
Garage.Flags.Sunshine6.Flame:= Sun6f.Checked;
Garage.Flags.Sunshine6.Explosion:= Sun6e.Checked;
Garage.Flags.Sunshine6.Damage:= Sun6d.Checked;
Garage.Flags.Sunshine7.Bullet:= Sun7b.Checked;
Garage.Flags.Sunshine7.Flame:= Sun7f.Checked;
Garage.Flags.Sunshine7.Explosion:= Sun7e.Checked;
Garage.Flags.Sunshine7.Damage:= Sun7d.Checked;
Garage.Flags.Sunshine8.Bullet:= Sun8b.Checked;
Garage.Flags.Sunshine8.Flame:= Sun8f.Checked;
Garage.Flags.Sunshine8.Explosion:= Sun8e.Checked;
Garage.Flags.Sunshine8.Damage:= Sun8d.Checked;
Garage.Flags.HymanCar1.Bullet:= hy1b.Checked;
Garage.Flags.HymanCar1.Flame:= hy1f.Checked;
Garage.Flags.HymanCar1.Explosion:= hy1e.Checked;
Garage.Flags.HymanCar1.Damage:= hy1d.Checked;
Garage.Flags.HymanCar2.Bullet:= hy2b.Checked;
Garage.Flags.HymanCar2.Flame:= hy2f.Checked;
Garage.Flags.HymanCar2.Explosion:= hy2e.Checked;
Garage.Flags.HymanCar2.Damage:= hy2d.Checked;
Garage.Flags.HymanCar3.Bullet:= hy3b.Checked;
Garage.Flags.HymanCar3.Flame:= hy3f.Checked;
Garage.Flags.HymanCar3.Explosion:= hy3e.Checked;
Garage.Flags.HymanCar3.Damage:= hy3d.Checked;
Garage.Flags.HymanCar4.Bullet:= hy4b.Checked;
Garage.Flags.HymanCar4.Flame:= hy4f.Checked;
Garage.Flags.HymanCar4.Explosion:= hy4e.Checked;
Garage.Flags.HymanCar4.Damage:= hy4d.Checked;
Garage.Flags.HymanCar5.Bullet:= hy5b.Checked;
Garage.Flags.HymanCar5.Flame:= hy5f.Checked;
Garage.Flags.HymanCar5.Explosion:= hy5e.Checked;
Garage.Flags.HymanCar5.Damage:= hy5d.Checked;
Garage.Flags.HymanCar6.Bullet:= hy6b.Checked;
Garage.Flags.HymanCar6.Flame:= hy6f.Checked;
Garage.Flags.HymanCar6.Explosion:= hy6e.Checked;
Garage.Flags.HymanCar6.Damage:= hy6d.Checked;
Garage.Flags.HymanCar7.Bullet:= hy7b.Checked;
Garage.Flags.HymanCar7.Flame:= hy7f.Checked;
Garage.Flags.HymanCar7.Explosion:= hy7e.Checked;
Garage.Flags.HymanCar7.Damage:= hy7d.Checked;
Garage.Flags.HymanCar8.Bullet:= hy8b.Checked;
Garage.Flags.HymanCar8.Flame:= hy8f.Checked;
Garage.Flags.HymanCar8.Explosion:= hy8e.Checked;
Garage.Flags.HymanCar8.Damage:= hy8d.Checked;
Garage.Flags.DiazCar1.Bullet:= di1b.Checked;
Garage.Flags.DiazCar1.Flame:= di1f.Checked;
Garage.Flags.DiazCar1.Explosion:= di1e.Checked;
Garage.Flags.DiazCar1.Damage:= di1d.Checked;
Garage.Flags.DiazCar2.Bullet:= di2b.Checked;
Garage.Flags.DiazCar2.Flame:= di2f.Checked;
Garage.Flags.DiazCar2.Explosion:= di2e.Checked;
Garage.Flags.DiazCar2.Damage:= di2d.Checked;
Garage.Flags.OceanCar.Bullet:= oceb.Checked;
Garage.Flags.OceanCar.Flame:= ocef.Checked;
Garage.Flags.OceanCar.Explosion:= ocee.Checked;
Garage.Flags.OceanCar.Damage:= oced.Checked;
Garage.Flags.LinksCar.Bullet:= linkb.Checked;
Garage.Flags.LinksCar.Flame:= linkf.Checked;
Garage.Flags.LinksCar.Explosion:= linke.Checked;
Garage.Flags.LinksCar.Damage:= linkd.Checked;
Garage.Flags.ElCar.Bullet:= elb.Checked;
Garage.Flags.ElCar.Flame:= elf.Checked;
Garage.Flags.ElCar.Explosion:= ele.Checked;
Garage.Flags.ElCar.Damage:= eld.Checked;
end;

procedure TGarageForm.Sun1MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun1Maj;
coloureditor.address:= 8222872;
end;

procedure TGarageForm.Sun1MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun1Min;
coloureditor.address:= $7D789C;
end;

procedure TGarageForm.Sun2MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun2Maj;
coloureditor.address:= $7D78C0;
end;

procedure TGarageForm.Sun2MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun2Min;
coloureditor.address:= $7D78C4;
end;

procedure TGarageForm.Sun3MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun3Maj;
coloureditor.address:= $7D7938;
end;

procedure TGarageForm.Sun3MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun3Min;
coloureditor.address:= $7D793C;
end;

procedure TGarageForm.Sun4MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun4Maj;
coloureditor.address:= $7D7960;
end;

procedure TGarageForm.Sun4MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun4Min;
coloureditor.address:= $7D7964;
end;

procedure TGarageForm.Sun5MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun5Maj;
coloureditor.address:= $7D79D8;
end;

procedure TGarageForm.Sun5MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun5Min;
coloureditor.address:= $7D79DC;
end;

procedure TGarageForm.Sun6MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun6Maj;
coloureditor.address:= $7D7A00;
end;

procedure TGarageForm.Sun6MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun6Min;
coloureditor.address:= $7D7A04;
end;

procedure TGarageForm.Sun7MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun7Maj;
coloureditor.address:= $7D7A78;
end;

procedure TGarageForm.Sun7MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun7Min;
coloureditor.address:= $7D7A7C;
end;

procedure TGarageForm.Sun8MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun8Maj;
coloureditor.address:= $7D7AA0;
end;

procedure TGarageForm.Sun8MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= Sun8Min;
coloureditor.address:= $7D7AA4;
end;

procedure TGarageForm.hy1MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy1Maj;
coloureditor.address:= $7D7578;
end;

procedure TGarageForm.hy1MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy1Min;
coloureditor.address:= $7D757C;
end;

procedure TGarageForm.hy2MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy2Maj;
coloureditor.address:= $7D75A0;
end;

procedure TGarageForm.hy2MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy2Min;
coloureditor.address:= $7D75A4;
end;

procedure TGarageForm.hy3MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy3Maj;
coloureditor.address:= $7D75C8;
end;

procedure TGarageForm.hy3MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy3Min;
coloureditor.address:= $7D75CC;
end;

procedure TGarageForm.hy4MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy4Maj;
coloureditor.address:= $7D75F0;
end;

procedure TGarageForm.hy4MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy4Min;
coloureditor.address:= $7D75F4;
end;

procedure TGarageForm.hy5MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy5Maj;
coloureditor.address:= $7D7618;
end;

procedure TGarageForm.hy5MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy5Min;
coloureditor.address:= $7D761C;
end;

procedure TGarageForm.hy6MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy6Maj;
coloureditor.address:= $7D7640;
end;

procedure TGarageForm.hy6MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy6Min;
coloureditor.address:= $7D7644;
end;

procedure TGarageForm.hy7MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy7Maj;
coloureditor.address:= $7D76B8;
end;

procedure TGarageForm.hy7MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy7Min;
coloureditor.address:= $7D76BC;
end;

procedure TGarageForm.hy8MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy8Maj;
coloureditor.address:= $7D76E0;
end;

procedure TGarageForm.hy8MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= hy8Min;
coloureditor.address:= $7D76E4;
end;

procedure TGarageForm.di1MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= di1Maj;
coloureditor.address:= $7D7B18;
end;

procedure TGarageForm.di1MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= di1Min;
coloureditor.address:= $7D7B1C;
end;

procedure TGarageForm.di2MajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= di2Maj;
coloureditor.address:= $7D7B40;
end;

procedure TGarageForm.di2MinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= di2Min;
coloureditor.address:= $7D7B44;
end;

procedure TGarageForm.oceMajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= oceMaj;
coloureditor.address:= $7D7758;
end;

procedure TGarageForm.oceMinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= oceMin;
coloureditor.address:= $7D775C;
end;

procedure TGarageForm.linksMajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= linksMaj;
coloureditor.address:= $7D77F8;
end;

procedure TGarageForm.linksMinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= linksMin;
coloureditor.address:= $7D77FC;
end;

procedure TGarageForm.elMajDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= elMaj;
coloureditor.address:= $7D74D8;
end;

procedure TGarageForm.elMinDblClick(Sender: TObject);
begin
Colours.Show;
coloureditor.box:= elMin;
coloureditor.address:= $7D74DC;
end;

end.
